#!/usr/bin/python
# getdss.py
#  Test program for fitsblink-Python interface
#  Jure Skvarc, January 2001
#  version 1.0

#  This is a Python interface to the fitsblink program
#  It is implemented using the SWIG program
#  Crashing the program is very easy, so do not take it as a challenge

import fitsblink
import sys
import astroparse

# Fitsblink must be started with option -s to know it is in script mode
arguments = ["fitsblink", "-s"] #  Define the command line tokens
argc = len(arguments)          
args = fitsblink.string_array(argc + 1) #  Create an array of chars
#  Put arguments into array
for i in range(argc):
    fitsblink.string_set(args, i, arguments[i])

try:
    file = sys.argv[1]
    object = sys.argv[2]
    ra = astroparse.strtora(sys.argv[3]) / 3600.0
    dec = astroparse.strtodec(sys.argv[4]) / 3600.0
    sizex = float(sys.argv[5])
    sizey = float(sys.argv[6])
except:
    sys.stderr.write('Wrong or missing input parameters!\n')
    sys.stderr.write('Usage:: getdss.py file.fts object hh:mm:ss.s +dd:mm:ss.ss width height\n')
    sys.stderr.write('Usage:: Image width and height are in arcminutes!\n')
    
fitsblink.string_set(args, argc, "")
# Start fitsblink and initialize graphic interface
fitsblink.main0(argc, args)
#  Switch to grey level colormap
fitsblink.colormap(1)
#  Resize and reposition the blinker window
#fitsblink.resize_blinker(500, 200, 500, 500)
#  Load a file and check success of this operation
if fitsblink.get_dss_image(file, object, ra, dec, sizex, sizey, 'DSS1') >= 0:
    print "Image successfully loaded"
else:
    print "Error loading the image"


fitsblink.load_image(file, 0)
#  If we set state.script to 0, fitsblink will stop
#  responding to script commands when it enters loop (see below)
fitsblink.state.script = 0

#  Detect stars on the image
fitsblink.Detect_stars(0)
fitsblink.Match_stars(0)

#  Enter the interactive loop
while 1:
    fitsblink.loop()


