#!/usr/bin/python
#  Test program for fitsblink-Python interface
#  Jure Skvarc, December 1999
#  version 1.0

#  This is a Python interface to the fitsblink program
#  It is implemented using the SWIG program
#  Crashing the program is very easy, so do not take it as a challenge

import fitsblink
import sys

# Fitsblink must be started with option -s to know it is in script mode
arguments = ["fitsblink", "-s"] #  Define the command line tokens
argc = len(arguments)          
args = fitsblink.string_array(argc + 1) #  Create an array of chars
#  Put arguments into array
for i in range(argc):
    fitsblink.string_set(args, i, arguments[i])

fitsblink.string_set(args, argc, "")
# Start fitsblink and initialize graphic interface
fitsblink.main0(argc, args)
#  Switch to grey level colormap
fitsblink.colormap(1)
#  Resize and reposition the blinker window
#fitsblink.resize_blinker(500, 200, 500, 500)
#  Load a file and check success of this operation
if fitsblink.load_image("/home/jure/c/fitsblink/examples/98kd3r5.fts", 0) >= 0:
    print "Image successfully loaded"
else:
    print "Error loading the image"

if fitsblink.load_image("/home/jure/c/fitsblink/examples/98kd3r6.fts", 0) >= 0:
    print "Image successfully loaded"
else:
    print "Error loading the image"

#  Set some values inside the image to 0
#  Test for swig_set_point
for i in range(10):
    for j in range(10):
        fitsblink.Set_point(0, i, j, 0)


#  Test for offset setting
fitsblink.Set_offset(1, 0.0, 1)

#  Print some pixel values
#  Test for swig_video_point
print "Pixel values from (100, 100) to (109, 109)"
for j in range(100, 110):
    for i in range(100, 110):
        print "%4d" % fitsblink.Video_point(0, i, j),
    print


#  If we set state.script to 0, fitsblink will stop
#  responding to script commands when it enters loop (see below)
fitsblink.state.script = 1

#  Detect stars on both images
fitsblink.Detect_stars(0)
fitsblink.Match_stars(0)
fitsblink.Blur(1)
fitsblink.Detect_stars(1)
#  List of stars
stars = fitsblink.frame[0].imagelist
matched = fitsblink.frame[0].cataloglist
#  Get number of counted stars from the first image
n = len(stars)
print n
for i in range(n):
    print '%4d. %8.3f %8.3f %8d %f' % (i, stars[i].x, stars[i].y, stars[i].mag, matched[stars[i].m].catnum)

fitsblink.Star_list(0)
fitsblink.Star_list(1)
fitsblink.Load_star_list(1, fitsblink.frame[0].fits.name)
#  Test of resize commands
fitsblink.resize_image(0, 100, 100, 200, 200)
fitsblink.resize_image(1, 100, 100, 200, 200)
#  Switch off markers in the first image
fitsblink.markers(0)
print 'Objnum=', fitsblink.frame[1].objnum
fitsblink.Append_marker(1, 100, 100, 10, 'TEST', 'red', 'uptriangle')
fitsblink.Remove_marker(1, 0)
print 'Objnum=', fitsblink.frame[1].objnum
fitsblink.Set_image(1)
fitsblink.Draw_image(1)
#  Set delay for blinking (interval between images in seconds)
fitsblink.set_delay(0.5)
#  Start blinking
fitsblink.blink(1)


while 1:
    fitsblink.loop()


