#!/usr/bin/perl
# tri.pl 1.0
#   Definicije parametrov
#=========================
#  Starcount

$prag = 2.0;    # Prag zaznave
$box = 30;    # Velikost okna, v katerem dolocam povprecno vrednost ozadja

#  Field_compare                                                                
$nstar = 15;  # Stevilo zvezd v konstelaciji
$bright = 60; # Stevilo svetlih pri zacetnem primerjanju
$minval = 5;  # Najmanjsa vrednost za sprejem konstelacije
$magerr = 3;  # Najvecja dovoljena razlika (faktor) v intenzitetah, da se objekta se ujemata
$poserr = 6;  # Najvecja razdalja v pikslih, da se objekta se ujemata 
$mindist = 10;#  Najmanjsa razdalja za zvezde v konstelaciji v pikslih
#  Find_triples
$magdiff = 1;  #  Najvecja dovoljena razlika v magnitudah, da objekt velja za isti
$distmax = 100; #  Najvecja dovoljena razdalja v pikslih med objektoma, ki nimata
               #  para, da lahko stejeta za isti objekt (-1 izracuna sam)       
$distmin = 1;  #  Najmanjsa razdalja, pri kateri se velja, da se je objekt premaknil
$magmin = 1; #  Kako sibke objekte (v magnitudah) glede na srednjo magnitudo    
               #  sploh gleda                                                   
$distance = 0.5;                                                                
$rate = 0.1;                                                                    

$home = $ENV{"HOME"};     #  "Home" imenik 
#  Preberem imena treh datotek iz ukazne vrstice
for ($i = 0; $i < 3; $i++) {
    $a = $ARGV[$i];
    print "Processing $a\n";

    chomp $a;
    next if $a eq ".fts";
    #  Obdelam sliko
    `starcount -l log.dat -s $prag -n 3.0 -o 12.0 -A -m $box $a`;
    $fless = $a;
    $fless =~ s/\.fts//g;
#  Naredim match s katalogom in vpisem prave koordinate
    `catalog -l log.dat -f $fless.dat -e 3 -n 12 -D 10 -m 12 -b 100 -r 2 -X 17.5 -W -A -c gscn:$home/astro/katalogi/gsc -c gscs:$home/astro/katalogi/gsc -c usno:$home/astro/katalogi/usno -c act:$home/astro/katalogi/act`;
    # Dobim prvi znak v imenu slike
    $s = substr $a, 0, 1;
    #   Ce je bila to druga slika ('b'), naredim se primerjavo s prvo 
    if ($i > 0) {
        $aless = substr $a, 1;
        #  Odrezem koncnico fts
        #  Naredim imeni z 'a' in 'b'
        if ($i == 1) {
	    $ps = $ARGV[0];
	    $ds = $ARGV[1];
        }
        else {
	    $ps = $ARGV[1];
	    $ds = $ARGV[2];
        }
        $ps =~ s/\.fts//g;
        $ds =~ s/\.fts//g;

        `field_compare -d $mindist -n $nstar -b $bright -m $minval -i $magerr -e $poserr  -l  log.dat $ps.dat $ds.dat >$ps-$ds.dat`;
#       $naxis1 = `buffers $a1 fits=NAXIS1 | awk '{print $3}'`;
        `find_moving -m 0.5 -u -1 -l log.dat -r 3 -b -1 $ps-$ds.dat`;
        # spremenil najmanjso razdaljo za premik (prej 1.4,2.0)
#       $distmin = ($naxis1 == 768) ? 1.2 : 1.7;
        #   Ce imam tretjo sliko, poiscem premicne objekte
        if ($i == 2)  {
	    $a1 = $ARGV[0];
	    $a1 =~ s/\.fts//g;
	    $b1 = $ARGV[1];
	    $b1 =~ s/\.fts//g;
	    $c1 = $ARGV[2];
	    $c1 =~ s/\.fts//g;
	    `find_triples -m $magdiff -u $distmax -l log.dat -r $distmin -b $magmin -d $distance -y $rate $a1-$b1.dat $b1-$c1.dat`;
	    `modifyinp.pl 18.5 $a1.inp`;
	    $n1=`wc $a1.inp | awk '{print $1}'`;
	    $nzad = ($n1 - 3) / 3;
	    printf "n=%d\n", $nzad;
	    `fitsblink -i $a1.inp-a\n`;
	}
    }
}
